/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 31/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.StrukturNomorDetail;
import com.portofolio.entity.vo.StrukturNomorDetailId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface StrukturNomorDetailMasterDao extends CrudRepository<StrukturNomorDetail, StrukturNomorDetailId> {

	@Cacheable("StrukturNomorDetailDaofindOneBy")
	StrukturNomorDetail findOneByIdKdStrukturNomorAndIdKdLevelTingkatAndIdKdProfileAndKdDepartemen(
			Integer kdStrukturNomor, Integer kdLevelTingkat, Integer kdProfile, String kdDepartemen);

	@Query(QListAll + " and model.id.kdStrukturNomor = :kdStrukturNomor")
	@Cacheable("StrukturNomorDetailDaoFindByKode")
	List<Map<String, Object>> findByKode(@Param("kdProfile") Integer kdProfile,
			@Param("kdDepartemen") String kdDepartemen, @Param("kdStrukturNomor") Integer kdStrukturNomor);

	String QListAll = "select new map(model.id as kode " + ", strukturNomor.namaStrukturNomor as namaStrukturNomor "
			+ ", levelTingkat.namaLevelTingkat as namaLevelTingkat " + ", model.qtyDigitKode as qtyDigitKode "
			+ ", model.kodeUrutAwal as kodeUrutAwal " + ", model.kodeUrutAkhir as kodeUrutAkhir "
			+ ", model.isAutoIncrement as isAutoIncrement " + ", model.formatKode as formatKode "
			+ ", model.statusResetNomor as statusResetNomor " + ", model.keteranganLainnya as keteranganLainnya "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec  , model.version as version "
			+ ", model.kdDepartemen as kdDepartemen, departemen.namaDepartemen as namaDepartemen )"
			+ " from StrukturNomorDetail model left join model.id id  " + " left join model.departemen as departemen "
			+ " left join model.strukturNomor strukturNomor " + " left join model.levelTingkat levelTingkat "
			+ " left join model.profile profile where profile.kode=:kdProfile and model.kdDepartemen=:kdDepartemen"
			+ " and  model.statusEnabled =true ";

	@Query(QListAll)
	@Cacheable("StrukturNomorDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page,
			@Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and strukturNomor.namaStrukturNomor like %:namaStrukturNomor% ")
	@Cacheable("StrukturNomorDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaStrukturNomor") String namaStrukturNomor, Pageable page,
			@Param("kdDepartemen") String kdDepartemen);

	@Modifying
	@Cacheable("setStatusEnabledFalseDao")
	// @Transactional
	@Query("update StrukturNomorDetail m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdStrukturNomor =:kdStrukturNomor")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile,
			@Param("kdStrukturNomor") Integer kdStrukturNomor);

	@Cacheable("countStrukturNomorDetail")
	Long countIdKdStrukturNomorByIdKdStrukturNomorAndIdKdProfile(Integer kdStrukturNomor, Integer kdProfile);

	List<StrukturNomorDetail> findListByIdKdStrukturNomorAndIdKdProfileOrderByIdKdLevelTingkatAsc(Integer kdStrukturNomor, Integer kdProfile);
}
